﻿Public Class BinarySearchTree
    Public root As Node

    Public Sub New()
        root = Nothing
    End Sub

    Public Sub Inserir(ByVal i As Integer)
        Dim novoNode As New Node()
        novoNode.iData = i
        If (root Is Nothing) Then
            root = novoNode
            Console.WriteLine("Criado o Nó raiz : " & i)
        Else
            Dim atual As Node = root
            Dim parent As Node
            While (True)
                parent = atual
                If (i < atual.iData) Then
                    atual = atual.Left
                    If (atual Is Nothing) Then
                        parent.Left = novoNode
                        Exit While
                    End If
                Else
                    atual = atual.Right
                    If (atual Is Nothing) Then
                        parent.Right = novoNode
                        Exit While
                    End If
                End If
            End While
            Console.WriteLine("Adicionado na árvore: " & i)
        End If
    End Sub

    Public Sub naOrdem(ByVal ARaiz As Node)
        If (Not (ARaiz Is Nothing)) Then
            naOrdem(ARaiz.Left)
            ARaiz.ExibirNode()
            naOrdem(ARaiz.Right)
        End If
    End Sub

    Public Sub preOrdem(ByVal ARaiz As Node)
        If (Not (ARaiz Is Nothing)) Then
            ARaiz.ExibirNode()
            preOrdem(ARaiz.Left)
            preOrdem(ARaiz.Right)
        End If
    End Sub

    Public Sub posOrdem(ByVal ARaiz As Node)
        If (Not (ARaiz Is Nothing)) Then
            posOrdem(ARaiz.Left)
            posOrdem(ARaiz.Right)
            ARaiz.ExibirNode()
        End If
    End Sub

    Public Function LocalizaMin() As Integer
        Dim current As Node = root
        While (Not (current.Left Is Nothing))
            current = current.Left
        End While
        Return current.iData
    End Function

    Public Function LocalizaMax() As Integer
        Dim current As Node = root
        While (Not (current.Right Is Nothing))
            current = current.Right
        End While
        Return current.iData
    End Function

End Class